#include "Camera.h"
#include "PsCameraman.h"
#include "PsSimulatedObject.h"

#include <PsController.h>
#include <PsNameToPointerMap.h>
#include <PsXEvent.h>
#include <Ps3DVisEvent.h>
#include <X11/keysym.h>
#include <Performer/pf.h>
#include <PsSystemEventIdentifier.h>
#include <PsPair.h>
#include <PsTranslationHPRRotation.h>
#include <PsvPartner.h>
#include <PsConfigurationParameterDescriptor.h>


//-----------------------------------------------------------------------------
Camera::Camera( PsController& ctrl,
			      const PsObjectDescriptor& objectDescriptor ) :
  PsCameraman ( ctrl, objectDescriptor )
{

}


//-----------------------------------------------------------------------------
Camera::~Camera( void )
{
}


//------------------------------clavier-----------------------------------------------
void
Camera::init( void )
{
  PsCameraman::init() ;

  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;

  PsName associatedVisualisation ;
   if (getConfigurationParameters ()->getSubDescriptorByName ("associatedVisualisation") != NULL) {
      associatedVisualisation = getConfigurationParameters ()
	->getSubDescriptorByName ("associatedVisualisation")
	->getAssociatedString () ;
      registerForSignalBy ("XEvent", associatedVisualisation) ;
   } else {
      registerForSignal ("XEvent") ;
   }
}

bool
Camera::processEvent(PsEvent * event)
{


if ( event->eventId == "XEvent" )
    {
      PsValuedEvent<PsXEvent>* valuedEvent =
	dynamic_cast<PsValuedEvent<PsXEvent>*>( event ) ;

      switch ( valuedEvent->value.getXEvent().type )
	{
	case KeyPress:
	  {
	    KeySym ks ;
	    char buf[100] ;
	    XLookupString( const_cast<XKeyEvent*>( &valuedEvent->value.getXEvent().xkey ), buf, sizeof( buf ), &ks, 0 ) ;
	    switch( ks )
	      {
	      case XK_Page_Up:
		{
		  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;
		  break ;
		}
	      case XK_Page_Down:
		{
		  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;
		  break ;
		}
              case 65361:
	      {
		  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;
		  break ;
	      }
	      case 65362:
	      {
		  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;
		  break ;
	      }
	      case 65363:
	      {
		  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;
		  break ;
	      }
	      case 65364:
	      {
		  cout<<"COORDONNEES DE LA CAMERA ET ORIENTATION (X,Y,Z,H,P,R) : "<<_positionOrientationOutput.getLastExactValue()<<endl;
		  break ;
	      }
	      default :
		break ;
	      }
	    break ;
	  }
	}
      return false ;
    }
  return PsSimulatedObject::processEvent( event ) ;
}
