#ifndef CAMILLE_H
#define CAMILLE_H

#include <PsSimulatedObject.h>
#include <PsvMechanismPartner.h>
#include <PsOutput.h>
#include <PsTranslationYRotation.h>
#include <PsYRotation.h>
#include <PsZRotation.h>

class Camille : 
public PsSimulatedObject, 
public PsvMechanismPartner
{
 public:
    Camille(PsController& ctrl, const PsObjectDescriptor& objectDescriptor);
    virtual ~Camille(void);

    virtual void init();
    virtual void compute();
    
 private:
    double theta;
    double angle;
    int inv;
    PsOutput<PsTranslationYRotation>& positionOutput;
    PsOutput<PsYRotation>& queueOutput;
    PsOutput<PsZRotation>& patteArDOutput;
    PsOutput<PsZRotation>& patteArGOutput;
    PsOutput<PsZRotation>& patteAvDOutput;
    PsOutput<PsZRotation>& patteAvGOutput;
};

#endif /* CAMILLE_H */
